;// ===============================================================
;//  ȻCCDOS97ʽ: C0MODU.ASM
;//  (ģCԳʼͷ)
;//
;//  Copyright (c) 1997,1998 Ȼʵ ½
;//  Tel: (010)68744479,68744489-207, 01381290625
;//  Email: jnchen@iname.com, chenus@public.bta.net.cn
;//  Internet: http://www.nease.net/~jnchen
;// ---------------------------------------------------------------


UNDERSCORE  EQU     1

            locals

PubSym@ 	MACRO   Sym, Definition, sName
        	IFNB    <sName>
        	IFIDN   <sName>, <__PASCAL__>
NAMING      =       0
        	ELSE
NAMING      =       UNDERSCORE
        	ENDIF
        	ENDIF
        	IF      NAMING
        	PUBLIC  _&Sym
_&Sym   	Definition
Sym&@   	equ     _&Sym
        	ELSE
        	PUBLIC  Sym
Sym     	Definition
Sym&@   	equ     Sym
        	ENDIF
        	ENDM

DGROUP		GROUP	_TEXT,_DATA,_CVTSEG,_SCNSEG,_INIT_,_INITEND_,_EXIT_,_EXITEND_,_BSS,_BSSEND


			ASSUME  CS:_TEXT, DS:DGROUP

_TEXT		SEGMENT BYTE PUBLIC 'CODE'

			.286

			extrn	_UtlHead	:byte

_abort		proc	near
			public	_abort
			ret
_abort		endp

_fnSaveTo	proc	near
			public	_fnSaveTo
			push	es
			push	di
			push	si
			push	ds
			pop 	es
			mov 	si, offset DGROUP:InitStart      ;si = start of table
			mov 	cx, offset DGROUP:InitEnd        ;di = end of table
			sub 	cx, si
			mov 	di, offset DGROUP:_saveto
			cld
			rep 	movsb
			pop 	si
			pop 	di
			pop 	es
			ret
_fnSaveTo	endp

;------------------------------------------------------------------
;  Loop through a startup/exit (SE) table,
;  calling functions in order of priority.
;  ES:SI is assumed to point to the beginning of the SE table
;  ES:DI is assumed to point to the end of the SE table
;  First 64 priorities are reserved by Borland
;------------------------------------------------------------------
PNEAR   	EQU 	0
PFAR    	EQU 	1
NOTUSED 	EQU 	0ffh

SE      	STRUC
calltype	db  	?                       ; 0=near,1=far,ff=not used
priority	db  	?                       ; 0=highest,ff=lowest
addrlow 	dw  	?
addrhigh	dw  	?
SE      	ENDS

_Initialize proc	near
			public	_Initialize

			push	di
			push	si
			push	bp
			push	ds
			pop 	es

			mov 	di, offset DGROUP:InitStart      ;si = start of table
			mov 	cx, offset DGROUP:InitEnd        ;di = end of table
			sub 	cx, di
			mov 	si, offset DGROUP:_saveto
			cld
			rep 	movsb

			xor 	bp, bp                   ; set BP to 0 for overlay mgr
			mov 	si, offset DGROUP:InitStart      ;si = start of table
			mov 	di, offset DGROUP:InitEnd        ;di = end of table
@Start:
			mov 	ax, 100h                 ;start with lowest priority
			mov 	dx, di                   ;set sentinel to end of table
			mov 	bx, si                   ;bx = start of table
@TopOfTable:
			cmp 	bx, di                   ;and the end of the table?
			je  	@EndOfTable            ;yes, exit the loop
			cmp 	es:[bx.calltype], NOTUSED;check the call type
			je  	@Next
			mov 	cl, es:[bx.priority]    ;move priority to CX
			xor 	ch, ch
			cmp 	cx, ax                   ;check the priority
			jae 	@Next                  ;too high?  skip
			mov 	ax, cx                   ;keep priority
			mov 	dx, bx                   ;keep index in dx
@Next:
			add 	bx, SIZE SE              ;bx = next item in table
			jmp 	@TopOfTable
@EndOfTable:
			cmp 	dx, di                   ;did we exhaust the table?
			je  	@Done                  ;yes, quit
			mov 	bx, dx                   ;bx = highest priority item
			cmp 	es:[bx.calltype], PNEAR  ;is it near or far?
			mov 	es:[bx.calltype], NOTUSED;wipe the call type
			push	es                      ;save es
			je  	@NearCall
@FarCall:
			call	DWORD PTR es:[bx.addrlow]
			pop 	es                      ;restore es
			jmp 	short @Start
@NearCall:
			call	WORD PTR es:[bx.addrlow]
			pop 	es                      ;restore es
			jmp 	short @Start
@Done:
			pop 	bp
			pop 	si
			pop 	di
			ret
_Initialize	endp

_Restore    proc	near
			public	_Restore

			push	ds
			pop 	es
            push    di
            push    si
            mov     si,offset DGROUP:ExitStart
            mov     di,offset DGROUP:ExitEnd

@@Start:    mov     ah,0                    ;start with highest priority
            mov     dx,di                   ;set sentinel to end of table
            mov     bx,si                   ;bx = start of table

@@TopOfTable:
			cmp     bx,di                   ;and the end of the table?
            je      @@EndOfTable            ;yes, exit the loop
            cmp     es:[bx.calltype],NOTUSED;check the call type
            je      @@Next
            cmp     es:[bx.priority],ah     ;check the priority
            jb      @@Next                  ;too low?  skip
            mov     ah,es:[bx.priority]     ;keep priority
            mov     dx,bx                   ;keep index in dx
@@Next:     add     bx,SIZE SE              ;bx = next item in table
            jmp     @@TopOfTable

@@EndOfTable:
			cmp     dx,di                   ;did we exhaust the table?
            je      @@Done                  ;yes, quit
            mov     bx,dx                   ;bx = highest priority item
            cmp     es:[bx.calltype],PNEAR  ;is it near or far?
            mov     es:[bx.calltype],NOTUSED;wipe the call type
            push    es                      ;save es
            je      @@NearCall

@@FarCall:  call    DWORD PTR es:[bx.addrlow]
            pop     es                      ;restore es
            jmp     short @@Start

@@NearCall: call    WORD PTR es:[bx.addrlow]
            pop     es                      ;restore es
            jmp     short @@Start

@@Done:
            pop     si
            pop     di
			ret
_Restore    endp

            ENDS


_DATA       SEGMENT PARA PUBLIC 'DATA'

_psp 		dw  	?
			public	_psp

__version 	dw  	?
			public	__version

_errno		dw  	?
			public	_errno


_saveto 	db  	68 dup(?)
			public	_saveto

;_emu		db  	044h dup (0)
;			db  	0CCh dup (?)
;			public  _emu

			db  	0, 'Thank you for using Chenus products!', 0

			ENDS

;PubSym@ 	DGROUP@, <dw    ?>, __PASCAL__


_CVTSEG 	SEGMENT
PubSym@ 	_RealCvtVector, <label  word>,  __CDECL__
			ENDS

_SCNSEG 	SEGMENT
PubSym@ 	_ScanTodVector,  <label word>,  __CDECL__
			ENDS

_INIT_  	SEGMENT WORD PUBLIC 'INITDATA'
InitStart	label	byte
			ENDS
_INITEND_	SEGMENT BYTE PUBLIC 'INITDATA'
InitEnd 	label	byte
			ENDS

_EXIT_  	SEGMENT WORD PUBLIC 'EXITDATA'
ExitStart	label	byte
			ENDS
_EXITEND_	SEGMENT BYTE PUBLIC 'EXITDATA'
ExitEnd 	label	byte
			ENDS

_BSS		SEGMENT
	;		db  	'BSS:'
bdata@  	label	byte
			ENDS

_BSSEND 	SEGMENT
edata@  	label	byte
	;		db  	'.BSS'
			ENDS

			end 	_UtlHead

