
#pragma 	inline

#include	<stdio.h>
#include	<stdlib.h>
#include	<dos.h>
#include	<conio.h>
#include	<time.h>

#pragma 		warn	-rvl
#pragma 		warn	-ret

	typedef unsigned char	BYTE;
	typedef unsigned int	WORD;
	typedef unsigned long	DWORD;

	typedef struct {
		WORD	hXM, uKB, xFree;
		DWORD	fpXMS, fpXMB;
		WORD	uPAR0, uPAR1, uPAR2, uPAR3,
				uPAR4, uPAR5, uPAR6, uPAR7;
		WORD	uRET0, uRET1, uRET2, uRET3;
		BYTE	uRETs[68];
	}	MODUCALL;

#define 	eHotKey 	1400h

#define 	eLE 		1
#define 	eX0 		25
#define 	eY0 		4

#define 	eMAJOR		1
#define 	eMINOR		0


void UtlHead(void)
{
	void far	fnOvlMain(void);
	void		fnOvlInit(void), fnCallCc16(void);
	void far	fnOvlQuit(void);

	asm {
		db  	'CC', 6, 0, 20h, 00h	// Mark, Major, Minor, Util, 0
		db  	eMAJOR, eMINOR, 00h, 0	// ModuMajor, ModuMinor, 0, 0
		dw  	0FFFFh					// Module Max length
		dw  	0FFFFh					// Module Max TSR length
		dw  	offset fnOvlEntry		// Module entry
	//	db  	'פ˹', 0
		db  	0D7h,0A4h, 0C1h,0F4h, 0B6h,0EDh, 0C2h,0DEh
		db  	0CBh,0B9h, 0B7h,0BDh, 0BFh,0E9h, 000h,000h
	}

	// ============================================================
	// 	IN:
	// 		ah = Func :
	// 			00h --- OVL module init
	// 			01h --- OVL module quit
	// 	OUT:
	// 		CF = NC: Ok.
	// ------------------------------------------------------------
	asm {
		fnOvlEntry	label	byte		// fnOvlEntry
		cmp 	ah, 01h
		jne 	oRetn
		db  	68h 					// push offset fnOvlQuit
		dw  	offset fnOvlQuit
		jmp 	lCall
	}
	oRetn:
	asm {
		oRetn	label	byte			// oRetn
		call	fnOvlInit
	//	stc
		retf

		fnKbIntr	label	byte		// Interrupt 16h
		sti
		test	ah, 11101110b
		jnz 	iOld16
		test	ah, 01h
		jz  	iOld16
		push	ds
		push	bx
		lds 	bx, dword ptr cs:_fpSysData
		mov 	al, byte ptr [bx+3Ah]	// SYSDATA.bCcMo
		and 	al, byte ptr [bx+3Dh]	// SYSDATA.bKbd
		pop 	bx
		pop 	ds
		jz  	iOld16				;// ״̬ת
		call	fnCallCc16
		jz  	iRet2
		cmp 	ax, eHotKey
		jne 	iRet2
		mov 	ah, 10h
		call	fnCallCc16
		push	cs
		db  	68h
		dw  	offset iRet0
		db  	68h
		dw  	offset fnOvlMain
		mov 	ax, cs
		jmp 	lCall

		iRet0	label	byte
		xor 	ax, ax
	}
	iRet2:
	asm {
		retf	2
	}
	iOld16:
	asm {
		db  	0EAh
		_fpOld16 	dd  	?
	}

	lCall:
	asm {
		lOvl0	label	byte			// lOvl0
		pop 	cs:sXMBuOffs
	//	retn
		mov 	cs:sXMBuAX, ax  		// Save SI, AX
								 		// When fpXmsServr returns,
										// it will restore SI & AX
										// automatically.
		mov 	ax, cs
		db  	0BEh 					// mov 	si, offset cs:sXMB
		dw  	offset cs:sXMB

		db  	0EAh
		fpXmbServr	dd  	?
	//	jmp 	dword ptr cs:fpXmbServr	// System swap call

		_fpSysData	dd  	?

		sXMB	label	byte			// sXMB
		sXMBhXmb	dw  	?
		sXMBuOffs	dw  	?
		sXMBuSI 	dw  	?
		sXMBuAX 	dw  	?
	}
}

void fnCallCc16(void)
{
	asm {
		pushf
		call	dword ptr cs:_fpOld16
	}
}

void ovlBegin(void)
{
}

		// ********************************************************
		// Overlay block begin:
		// --------------------------------------------------------

#define 		eStack		2048

	BYTE		szStack[eStack];
	WORD		uSS, uSP, uSEG, uCursor;

	BYTE		szRelocate[80] = "RELOCATE";

	static struct BLOCK {
			int 	x0, y0, x1, y1, x2, y2, x3, y3;
			int 	color;
			int 	next;
	}	b[23] =
	{
				{	0, 1, 1, 1, 2, 1, 3, 1,  4,  1	},
				{	1, 0, 1, 3, 1, 2, 1, 1,  4,  0  },
				{	1, 1, 2, 2, 1, 2, 2, 1,  1,  2  },
				{	0, 1, 1, 1, 1, 0, 2, 0,  2,  4  },
				{	1, 0, 1, 1, 2, 2, 2, 1,  2,  5  },
				{	0, 2, 1, 2, 1, 1, 2, 1,  2,  6  },
				{	0, 0, 0, 1, 1, 2, 1, 1,  2,  3  },
				{	0, 0, 1, 0, 1, 1, 2, 1,  3,  8  },
				{	0, 1, 0, 2, 1, 1, 1, 0,  3,  9  },
				{	0, 1, 1, 1, 1, 2, 2, 2,  3, 10  },
				{	1, 1, 1, 2, 2, 1, 2, 0,  3,  7  },
				{	1, 0, 1, 1, 1, 2, 2, 2,  7, 12  },
				{	0, 1, 1, 1, 2, 1, 2, 0,  7, 13  },
				{	0, 0, 1, 2, 1, 1, 1, 0,  7, 14  },
				{	0, 1, 0, 2, 1, 1, 2, 1,  7, 11  },
				{	0, 2, 1, 2, 1, 1, 1, 0,  5, 16  },
				{	0, 1, 1, 1, 2, 2, 2, 1,  5, 17  },
				{	1, 0, 1, 1, 1, 2, 2, 0,  5, 18  },
				{	0, 0, 0, 1, 1, 1, 2, 1,  5, 15  },
				{	0, 1, 1, 1, 1, 0, 2, 1,  6, 20  },
				{	0, 1, 1, 2, 1, 1, 1, 0,  6, 21  },
				{	0, 1, 1, 2, 1, 1, 2, 1,  6, 22  },
				{	1, 0, 1, 1, 1, 2, 2, 1,  6, 19  }
	};

	static int	d[10] =
	{
				1500,3000,1600,1200,900,800,600,400,300,200
	};
	int			level, current, next, able, lx, ly, sum;
	unsigned	point, MaxPoint;
	int			la[19][10], FLAG, bell, sum, bGraph;
	unsigned	ldelay;
	BYTE		szLine[64];

	void far	(*fpCcVideo)(void);


void fnDot(int x0, int y0, BYTE bColor)
{
	asm {
		mov 	ah, 10h
		mov 	bh, 0
		mov 	bl, byte ptr bColor
		mov 	cx, word ptr x0
		mov 	dx, word ptr y0
		xor 	di, di
		call	dword ptr fpCcVideo
	}
}

void fnLinex(int x0, int y0, int x1, BYTE bColor, WORD wStyle)
{
	asm {
		push	bp
		mov 	ah, 16h
		mov 	bh, 0
		mov 	bl, byte ptr bColor
		mov 	cx, word ptr x0
		mov 	dx, word ptr y0
		mov 	si, word ptr x1
		mov 	bp, word ptr wStyle
		call	dword ptr fpCcVideo
		pop 	bp
	}
}

void fnLiney(int x0, int y0, int y1, BYTE bColor, WORD wStyle)
{
	asm {
		push	bp
		mov 	ah, 17h
		mov 	bh, 0
		mov 	bl, byte ptr bColor
		mov 	cx, word ptr x0
		mov 	dx, word ptr y0
		mov 	di, word ptr y1
		mov 	bp, word ptr wStyle
		call	dword ptr fpCcVideo
		pop 	bp
	}
}

void fnLines(int x0, int y0, int x1, int y1, BYTE bColor, WORD wStyle)
{
	asm {
		push	bp
		mov 	ah, 1Eh
		mov 	bh, 0
		mov 	bl, byte ptr bColor
		mov 	cx, word ptr x0
		mov 	dx, word ptr y0
		mov 	si, word ptr x1
		mov 	di, word ptr y1
		mov 	bp, word ptr wStyle
		call	dword ptr fpCcVideo
		pop 	bp
	}
}

void fnButton(int x0, int y0, int x1, int y1, BYTE color, BYTE updn)
{
	x1 ++;  y1 ++;
	x0 *= 8;  x1 *= 8;  y0 *= 18;  y1 *= 18;
	if (! updn) {
		x0 --; y0 --; x1 ++;  y1 ++;
	}
	fnLinex(x0, y0, x1, updn ? 0x0F : 0, 0xFFFF);
	fnLiney(x0, y0, y1, updn ? 0x0F : 0, 0xFFFF);
	fnLinex(x0+1, y1, x1, updn ? 0 : 0x0F, 0xFFFF);
	fnLiney(x1, y0+1, y1, updn ? 0 : 0x0F, 0xFFFF);
}

void fnUpDown(int x0, int y0, int x1, int y1)
{
	x1 ++;  y1 ++;
	x0 *= 8;  x1 *= 8;  y0 *= 18;  y1 *= 18;
	x0 += 5;  y0 += 5;  x1 -= 5;  y1 -= 5;
	fnLinex(x0, y0, x1, 0, 0xFFFF);
	fnLiney(x0, y0, y1, 0, 0xFFFF);
	fnLinex(x0+1, y1, x1, 0xFF, 0xFFFF);
	fnLiney(x1, y0+1, y1, 0xFF, 0xFFFF);
	x0 ++;  y0 ++;  x1 --;  y1 --;
	fnLinex(x0, y0, x1, 0xFF, 0xFFFF);
	fnLiney(x0, y0, y1, 0xFF, 0xFFFF);
	fnLinex(x0+1, y1, x1, 0, 0xFFFF);
	fnLiney(x1, y0+1, y1, 0, 0xFFFF);
}

void scrolldn(BYTE x0, BYTE y0, BYTE x1, BYTE y1)
{
	asm {
		pusha
		mov 	ah, 0Bh
		mov 	bx, 0001h
		mov 	cl, byte ptr x0
		mov 	ch, byte ptr y0
		sub 	cx, 0101h
		mov 	dl, byte ptr x1
		dec 	cl
		mov 	dh, byte ptr y1
		cli
		call	dword ptr fpCcVideo
		sti
		popa
	}
}

void fnRect(int x0, int y0, int x1, int y1, BYTE bColor, WORD wStyle)
{
	fnLinex(x0, y0, x1, bColor, wStyle);
	fnLiney(x0, y0, y1, bColor, wStyle);
	fnLinex(x0, y1, x1, bColor, wStyle);
	fnLiney(x1, y0, y1, bColor, wStyle);
}

void putstr(char *pstr, int color, int x, int y)
{
	asm {
		mov 	dh, byte ptr y
		dec 	dh
		mov 	dl, byte ptr x
		dec 	dl
		xor 	bh, bh
		mov 	bl, byte ptr color
		mov 	si, word ptr pstr
		xor 	cx, cx
	}
	lLoop0:
	asm {
		cld
		lodsb
		or  	al, al
		jz  	lRetn
		mov 	cl, al
		pusha
		mov 	ah, 06h
		call	dword ptr fpCcVideo
		popa
		xor 	cx, cx
		inc 	dl
		jmp 	lLoop0
	}
	lRetn:	;
}

void putccs(char *pstr, int color, int x, int y)
{
	asm {
		mov 	dh, byte ptr y
		dec 	dh
		mov 	dl, byte ptr x
		dec 	dl
		mov 	bl, byte ptr color
		mov 	bh, bl
		mov 	si, word ptr pstr
		xor 	cx, cx
	}
	lLoop0:
	asm {
		cld
		lodsb
		or  	al, al
		jz  	lRetn
		mov 	cl, al
		cmp 	cl, 0A0h
		jb  	lEc
		or  	ch, ch
		jnz 	lCc
		mov 	ch, cl
		jmp 	lLoop0
	}
	lEc:
	asm {
		pusha
		mov 	ah, 06h
		call	dword ptr fpCcVideo
		popa
		xor 	cx, cx
		inc 	dl
		jmp 	lLoop0
	}
	lCc:
	asm {
		pusha
		mov 	ah, 07h
		call	dword ptr fpCcVideo
		popa
		xor 	cx, cx
		inc 	dl
		inc 	dl
		jmp 	lLoop0
	}
	lRetn:	;
}

void drawone(int x, int y, int color)
{
	BYTE		bHi, bLo,
				aHi[8] = { 0, 9, 10, 11, 12, 13,  7, 15 },
				aLo[8] = { 0, 0,  0,  0,  0,  0,  0,  0 };
	int 		x0, y0, x1, y1;

	putstr("", color, x, y);
	x --;  y --;
	x0 = x*8;  x1 = x0+15;
	y0 = y*18;  y1 = y0+17;
	bHi = aHi[color];  bLo = aLo[color];
	fnLinex(x0, y0, x1, bHi, 0xFFFF);
	fnLiney(x0, y0, y1, bHi, 0xFFFF);
	fnLinex(x0+1, y1, x1, bLo, 0xFFFF);
	fnLiney(x1, y0+1, y1, bLo, 0xFFFF);
}

/* display blocks */
void dispb(int x, int y, int bNo)
{
	int		realx, realy;

	realx = eX0+x*2;  realy = eY0+y;
	drawone(realx+2*b[bNo].x0, realy+b[bNo].y0, b[bNo].color);
	drawone(realx+2*b[bNo].x1, realy+b[bNo].y1, b[bNo].color);
	drawone(realx+2*b[bNo].x2, realy+b[bNo].y2, b[bNo].color);
	drawone(realx+2*b[bNo].x3, realy+b[bNo].y3, b[bNo].color);
}

/* erase blocks */
void eraseb(int x, int y, int bNo)
{
	int 	realx, realy;

	realx = eX0+x*2;  realy = eY0+y;
	drawone(realx+2*b[bNo].x0, realy+b[bNo].y0, 0);
	drawone(realx+2*b[bNo].x1, realy+b[bNo].y1, 0);
	drawone(realx+2*b[bNo].x2, realy+b[bNo].y2, 0);
	drawone(realx+2*b[bNo].x3, realy+b[bNo].y3, 0);
}

int rjudge(void)
{
	int 	i, j;

	for (i = 0; i < 3; i++)
		for (j = 0; j < 3; j++)
			if (la[ly+i][lx+j] != 0) return(-1);
	return(1);
}

int drop(void)
{
	if (ly+b[current].y1 >= 18 || ly+b[current].y2 >= 18)
	{
		la[ly+(b[current].y0)][lx+(b[current].x0)] =
		la[ly+(b[current].y1)][lx+(b[current].x1)] =
		la[ly+(b[current].y2)][lx+(b[current].x2)] =
		la[ly+(b[current].y3)][lx+(b[current].x3)] = b[current].color;
		return(-1);
	}
	if (la[ly+1+(b[current].y0)][lx+(b[current].x0)] != 0 ||
		la[ly+1+(b[current].y1)][lx+(b[current].x1)] != 0 ||
		la[ly+1+(b[current].y2)][lx+(b[current].x2)] != 0 ||
		la[ly+1+(b[current].y3)][lx+(b[current].x3)] != 0 )
	{
		la[ly+(b[current].y0)][lx+(b[current].x0)] =
		la[ly+(b[current].y1)][lx+(b[current].x1)] =
		la[ly+(b[current].y2)][lx+(b[current].x2)] =
		la[ly+(b[current].y3)][lx+(b[current].x3)] = b[current].color;
		return(-1);
	}
	eraseb(lx, ly++, current);
	dispb(lx, ly, current);
	return(0);
}

int judge(void)
{
	int 		ii, jj, kk, ll;
	int 		i, j, k,lines, f, codebuffer[4][10];
	static int	p[5] = { 0, 100, 300, 600, 1000 };

	lines = 0;
	for (k = 0; k <= 3; k++) {
		f = 0;
		if ((ly+k) > 18)
			continue;
		for (i = 0; i < 10; i++)
			if (la[ly+k][i] == 0) {
				f++;  break;
			}
		if (f == 0) {
			for (j = 0; j < 10; j++)
				codebuffer[lines][j] = la[ly+k][j];
			if (b[current].y0 == k) {
				putstr("  ", 0, eX0+2*(lx+b[current].x0), eY0+k+ly);
				codebuffer[lines][lx+b[current].x0] = 0;
			}
			if (b[current].y1 == k) {
				putstr("  ", 0, eX0+2*(lx+b[current].x1), eY0+k+ly);
				codebuffer[lines][lx+b[current].x1] = 0;
			}
			if (b[current].y2 == k) {
				putstr("  ", 0, eX0+2*(lx+b[current].x2), eY0+k+ly);
				codebuffer[lines][lx+b[current].x2] = 0;
			}
			if (b[current].y3 == k) {
				putstr("  ", 0, eX0+2*(lx+b[current].x3), eY0+k+ly);
				codebuffer[lines][lx+b[current].x3] = 0;
			}

			scrolldn(eX0, eY0, eX0+19, eY0+ly+k-1);

			for (i = (ly+k); i > 0; i--)
				for (j = 0; j < 10; j++) la[i][j] = la[i-1][j];
			for (j = 0; j < 10; j++) la[0][j] = 0;
			lines ++;
		}
	}
	if (lines >= 2 && bell) putchar(7);
	point += p[lines];
	if (point > MaxPoint) MaxPoint = point;
	return(0);
}


void question(void)
{
}

void throw(void)
{
	int		tempy;

	tempy = ly;
	while ( ly+b[current].y1 < 19 && ly+b[current].y2 < 19 &&
			la[ly+(b[current].y0)][lx+(b[current].x0)]==0 &&
			la[ly+(b[current].y1)][lx+(b[current].x1)]==0 &&
			la[ly+(b[current].y2)][lx+(b[current].x2)]==0 &&
			la[ly+(b[current].y3)][lx+(b[current].x3)]==0 )
		ly++;
	ly--;
	eraseb(lx, tempy, current);
	dispb(lx, ly, current);
	la[ly+(b[current].y0)][lx+(b[current].x0)] =
	la[ly+(b[current].y1)][lx+(b[current].x1)] =
	la[ly+(b[current].y2)][lx+(b[current].x2)] =
	la[ly+(b[current].y3)][lx+(b[current].x3)] = b[current].color;
	able = -1;
}

void DropStep(void)
{
	if (ly+1+b[current].y1 < 19 && ly+1+b[current].y2 < 19 &&
		la[ly+1+(b[current].y0)][lx+(b[current].x0)] == 0 &&
		la[ly+1+(b[current].y1)][lx+(b[current].x1)] == 0 &&
		la[ly+1+(b[current].y2)][lx+(b[current].x2)] == 0 &&
		la[ly+1+(b[current].y3)][lx+(b[current].x3)] == 0 )
	{
		eraseb(lx, ly++, current);
		dispb(lx, ly, current);
	}
	else
	{
		la[ly+(b[current].y0)][lx+(b[current].x0)] =
		la[ly+(b[current].y1)][lx+(b[current].x1)] =
		la[ly+(b[current].y2)][lx+(b[current].x2)] =
		la[ly+(b[current].y3)][lx+(b[current].x3)] = b[current].color;
		able = -1;
	}
}

int yRandom(int mmax)
{
	asm {
		push	es
		xor 	ax, ax
		mov 	es, ax
		xor 	dx, dx
		mov 	ax, es:[46Ch]
		div 	word ptr mmax
		pop 	es
	}
	return _DX;
}

int nextb(void)
{
	if (la[(b[next].y0)][(3+b[next].x0)] != 0 ||
		la[(b[next].y1)][(3+b[next].x1)] != 0 ||
		la[(b[next].y2)][(3+b[next].x2)] != 0 ||
		la[(b[next].y3)][(3+b[next].x3)] != 0 )
	{
		FLAG = eLE;  return(-1);
	}
	eraseb(12, 3, next);
	current = next;
	lx = 3;  ly = 0;
	able = 0;
	ldelay = d[0];
	sum ++;  point += 10;
	if (point > MaxPoint) MaxPoint = point;
	next = yRandom(26);
	if (next == 23) next = 0;
	if (next == 24 || next == 25) next = 2;
	dispb(12, 3, next);

	itoa(sum, szLine, 10);
	putstr(szLine, 0x07, eX0+27-(sum>=100), 13);
	itoa(point, szLine, 10);
	putstr(szLine, 0x07, eX0+27-(point>=100), 16);
	itoa(MaxPoint, szLine, 10);
	putstr(szLine, 0x07, eX0+27-(MaxPoint>=100), 19);
	return(0);
}

void move(unsigned short funckey)
{
	int 	tNo;

	switch (funckey) {
		case 0x4B00:				// <-- Left
			if (lx+b[current].x0 > 0)
				if (la[ly+(b[current].y0)][lx-1+(b[current].x0)] == 0 &&
					la[ly+(b[current].y1)][lx-1+(b[current].x1)] == 0 &&
					la[ly+(b[current].y2)][lx-1+(b[current].x2)] == 0 &&
					la[ly+(b[current].y3)][lx-1+(b[current].x3)] == 0)
				{
					eraseb(lx, ly, current);
					lx --;
					dispb(lx, ly, current);
				}
			break;
		case 0x4800:				// Rotate
			tNo = b[current].next;
			if (lx+b[tNo].x0 >= 0 && lx+b[tNo].x3 <= 9 &&
				ly+b[tNo].y1 <=19 && ly+b[tNo].y2 <= 19)
				if (rjudge() != -1)
					if (la[ly+(b[tNo].y0)][lx+(b[tNo].x0)] == 0 &&
						la[ly+(b[tNo].y1)][lx+(b[tNo].x1)] == 0 &&
						la[ly+(b[tNo].y2)][lx+(b[tNo].x2)] == 0 &&
						la[ly+(b[tNo].y3)][lx+(b[tNo].x3)] == 0 )
					{
						eraseb(lx, ly, current);
						current = tNo;
						dispb(lx, ly, current);
					}
			break;
		case 0x4D00:				// --> Right
			if (lx+b[current].x3 < 9)
				if (la[ly+(b[current].y0)][lx+1+(b[current].x0)] == 0 &&
					la[ly+(b[current].y1)][lx+1+(b[current].x1)] == 0 &&
					la[ly+(b[current].y2)][lx+1+(b[current].x2)] == 0 &&
					la[ly+(b[current].y3)][lx+1+(b[current].x3)] == 0 )
				{
					eraseb(lx++, ly, current);
					dispb(lx, ly, current);
				}
			break;

		case 0x5000:
			DropStep();  break;

		case ' ':					// Drop
			throw();  break;

		case 0x1B:
			break;

		default:
			break;
	}
}

void fnTimer(void)
{
	asm {
		mov 	ah, 00h
		int 	1Ah 			;// cx:dx = ticker
		mov 	ax, dx
	}
}

unsigned short fnWaitKey(int timer)
{
	fnTimer();
	asm {
		add 	ax, word ptr timer
		mov 	si, ax
	}
	lLoop0:
	asm {
		mov 	ah, 11h
		pushf
		call	dword ptr cs:fpOld16
	//	int 	16h
		jnz 	lGets
	}
	fnTimer();
	asm {
		cmp 	ax, si
		jb  	lLoop0
	}
	return 0x5000;

	lGets:
	asm {
		mov 	ah, 10h
		pushf
		call	dword ptr cs:fpOld16
	//	int 	16h
		or  	al, al
		jz  	lRetn
		cmp 	al, 0E0h
		je  	lCont0
		xor 	ah, ah
		cmp 	ax, 001Bh
		jne 	lCont0
		xor 	ax, ax
	}
	lCont0:
	asm {
		or  	ah, ah
		jz  	lRetn
		xor 	al, al
	}
	lRetn:	return _AX;
}

unsigned short delayp(void)
{
	unsigned short key;

	if ((key = fnWaitKey(18/2)) != 0) move(key);
	return key;
}

void scrinit(void)
{
	char	lft[20], rght[20];
	int 	i;

	asm {
		mov 	ah, 1
		mov 	cx, 2000h
		int 	10h
		mov 	ah, 0Ah
		mov 	bx, 7000h
		mov 	cl, eX0-3
		mov 	ch, eY0-2
		mov 	dl, eX0+33
		mov 	dh, eY0+18
		call	dword ptr fpCcVideo
	}
	fnButton(eX0-3, eY0-2, eX0+33, eY0+18, 7, 1);
	fnUpDown(eX0-3, eY0-2, eX0+33, eY0+18);

	putccs("һ", 0x75, eX0+24, 5);
	putccs("ֿ", 0x74, eX0+24, 12);
	putccs("ֵ÷", 0x74, eX0+24, 15);
	putccs("ߵ÷", 0x74, eX0+24, 18);
	putccs("˹", 0x78, eX0+23, 22);

	asm {
		mov 	ah, 0Ah
		mov 	bx, 0700h
		mov 	cl, eX0+21
		mov 	ch, eY0+1
		mov 	dl, eX0+31
		mov 	dh, eY0+5
		call	dword ptr fpCcVideo
	}
	fnButton(eX0+21, eY0+1, eX0+31, eY0+5, 7, 0);

	asm {
		mov 	ah, 0Ah
		mov 	bx, 0700h
		mov 	cl, eX0-1
		mov 	ch, eY0-1
		mov 	dl, eX0+18
		mov 	dh, eY0+17
		call	dword ptr fpCcVideo
	}
	fnButton(eX0-1, eY0-1, eX0+18, eY0+17, 7, 0);
}

void datainit(void)
{
	int 	i, j;

	for (i = 0; i < 19; i++)
		for (j = 0; j < 10; j++) la[i][j] = 0;

	FLAG = 0;
	able = bell = 0;
	ldelay = d[0];
	sum = point = 0;
	next = yRandom(26)+3;
	if (next == 23) next = 0;
	else
	if (next >= 24) next = 2;
}

// ===============================================================
//  	IN:
// ---------------------------------------------------------------
void far fnOvlMain(void)
{
	void	fnRelocate(void);

	asm {
		push	ds
		push	cs
		pop 	ds
		mov 	word ptr cs:uSS, ss
		mov 	word ptr cs:uSP, sp
		cli
		push	cs
		pop 	ss
		mov 	sp, offset szStack + eStack
		sti
		push	es
		pusha
		mov 	cs:uSEG, ax
		mov 	ds, ax
		lds 	bx, dword ptr ds:_fpSysData
		mov 	byte ptr [bx+44h], 1
		les 	bx, dword ptr [bx+10h]
		mov 	ah, 3
		int 	10h
		push	cs
		pop 	ds
		mov 	uCursor, cx
		mov 	word ptr fpCcVideo, bx
		mov 	word ptr fpCcVideo+2, es
	}
	fnRelocate();

	scrinit();
	datainit();

	while (nextb() == 0 && FLAG == 0)
	{
		while (FLAG == 0)
		{
			able = drop();

			while (1)
			{
				if (! delayp()) goto lRetn;

				if (able != 0) {
					judge();  able = nextb();
				}
				ldelay--;
				if (ldelay == 0) {
					able = drop();  ldelay = d[0];
				}
				if (FLAG != 0) break;
			}
			if (FLAG != 0) break;
		}
		if (FLAG != 0) break;
	}

	lRetn:
	asm {
		mov 	ah, 1
		mov 	cx, uCursor
		int 	10h
		mov 	ds, cs:uSEG
		lds 	bx, dword ptr ds:_fpSysData
		mov 	byte ptr [bx+44h], 0
		push	cs
		pop 	ds
		mov 	ax, 1409h
		int 	10h
		popa
		pop 	es
		cli
		mov 	ss, word ptr cs:uSS
		mov 	sp, word ptr cs:uSP
		sti
		pop 	ds
	}
}

void far fnOvlQuit(void)
{
	asm {
		push	ds
		mov 	ax, 2516h
		lds 	dx, dword ptr cs:fpOld16
		int 	21h
		pop 	ds
		xor 	ax, ax
	}
	return;
	asm {
		fpOld16	dd  	?
	}
}

	// ************************************************************
	//  		Overlay block end.
	// ------------------------------------------------------------

// ===============================================================
// 	IN:
// 		es:bx = Parameter Struc:
// 		   bx.hXM		hXMS of system
// 		   bx.uKB		XMS size (KB)
// 		   bx.xFree		XMS free (KB)
// 		   bx.fpXMS 	fpXmsServer
// 		   bx.fpXMB 	fpXmbLoadr
// 		   bx.uPAR0 	fpSysData
// 		   bx.uPAR2 	fpFuHaoMb
// 		   bx.uPAR4		bFuncKey
// 		   bx.uPAR6
// 		   bx.uRET0
// 		   bx.uRET1
// 	OUT:
// 		ax = 0000h: Ok.
// 		cx = TSR size
// ---------------------------------------------------------------
void fnOvlInit(void)
{
	void		fnLoadToXMB(void), fnUpModule(void);

	asm {
		push	ds
		push	cs
		pop 	ds
		mov 	word ptr oRetn, 0CBF9h	// stc; retf
	//	assume	bx:ptr MODUCALL
		mov 	ax, word ptr es:[bx].uPAR0
		mov 	dx, word ptr es:[bx].uPAR1
		mov 	word ptr _fpSysData, ax
		mov 	word ptr _fpSysData+2, dx

		push	es
		push	bx
		mov 	ax, 3516h
		int 	21h
		mov 	word ptr _fpOld16, bx
		mov 	word ptr _fpOld16+2, es
		mov 	word ptr fpOld16, bx
		mov 	word ptr fpOld16+2, es
		pop 	bx
		pop 	es

		call	fnLoadToXMB
		jnz 	lFailx

		mov 	cx, offset ovlBegin
		mov 	ax, cs
		cmp 	ax, 0A000h
		jae 	lRet0
		call	fnUpModule				// if cx==0 then bx=UMB.
		jmp 	lRet0
	}
	lFailx:
	asm {
		mov 	cx, word ptr ds:[000Ch]
		mov 	ax, cs
	}
	lRet0:
	asm {
		mov 	ds, ax
		mov 	es, ax
		mov 	ax, 2516h
		mov 	dx, offset fnKbIntr
		int 	21h
		xor 	ax, ax
		pop 	ds
	}
}

void fnRelocate(void)
{
	extern void fnSaveTo(void);

	asm {
		jmp 	lReloc

		isFirst	dw  	5555h
	}
	lReloc:
	asm {
		cmp 	isFirst, 5555h
		jne 	lRetn
		mov 	isFirst, 1111h

		call	fnSaveTo				// Save SE table

		mov 	si, offset szRelocate + 8
		mov 	ax, ds
		mov 	cx, 80/4
	}
	lLoop0:
	asm {
		mov 	bx, [si]
		or  	bx, bx
		jz  	lRetn
		add 	word ptr [bx], ax
		add 	si, 4
		loop	lLoop0
	}
	lRetn:	;
}

// ================================================================
//  	IN:
//
//  	OUT:
//  		dx = handle of XMB
//  		es:bx = fpXmbServer
// ----------------------------------------------------------------
void fnLoadToXMB(void)
{
	asm {
		push	es
		push	bx
		mov 	cx, word ptr ds:[000Ch]
		mov 	ax, offset ovlBegin
		and 	ax, 0FFF0h
		sub 	cx, ax
		mov 	si, offset ovlBegin
		call	dword ptr es:[bx].fpXMB	// fpXmbLoadr
	}

	if (_AX == 0)
	asm {
		mov 	word ptr cs:fpXmbServr, bx
		mov 	word ptr cs:fpXmbServr+2, es
	//	mov 	byte ptr cs:sXMB.uAX+1, 0FFh
		mov 	cs:sXMBhXmb, dx
	}
	else
	asm {
		mov 	byte ptr lOvl0, 0C3h	// retn
	}

	asm {
		pop 	bx
		pop 	es
	}
}

// ================================================================
//  	IN:
//  		cx = len
//  	OUT:
//  		ax = new SEG
// ----------------------------------------------------------------
void fnUpModule(void)
{
	asm {
		mov 	dx, cx
		int 	68h
		or  	ax, ax
		mov 	ax, cs
		jnz 	uRetn
		push	es
		mov 	es, bx
		xor 	di, di
		xor 	si, si
		cld
		rep 	movsb

		pop 	es
		mov 	ax, bx				// set new DS to load intr
		xor 	cx, cx
	}
	uRetn:	;
}


